#version 330 core


layout (location = 0) in vec3 aPos;
layout (location = 1) in vec3 aNormal;
layout (location = 2) in vec2 aTexCoord;

out vec2 TexCoord;
out vec3 Normal;
out vec3 FragPos;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;


void main(){
    gl_Position = projection*view*model*vec4(aPos, 1.0);

    //mat3 normalMat = mat3(model);
    //normalMat = transpose(inverse(normalMat));
    //vec3 normal_transformed = vec3(0.0);
    //normal_transformed = normalize(normalMat*aNormal);
    //Normal = normal_transformed;
    FragPos = vec3(model*vec4(aPos, 1.0));
    Normal = mat3(transpose(inverse(model))) * aNormal;
    TexCoord = aTexCoord;
}
